//------------------------------------------------------------------
//
//------------------------------------------------------------------
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"

#property indicator_chart_window
#property indicator_buffers 2
#property indicator_color1  DodgerBlue
#property indicator_color2  Red

//
//
//
//
//

extern string TimeFrame        = "Current time frame";
extern int    FastMa           = 12;
extern int    SlowMa           = 26;
extern int    SignalMa         = 9;
extern int    mamode           = 1;
extern int    Price            = PRICE_CLOSE;

extern string _                = "alerts settings";
extern bool   alertsOn         = true;
extern bool   alertsOnCurrent  = false;
extern bool   alertsMessage    = true;
extern bool   alertsSound      = false;
extern bool   alertsEmail      = false;

//
//
//
//
//

double macduw[];
double macddw[];
double signal[];
double trend[];

//
//
//
//
//

string indicatorFileName;
int    timeFrame;
bool   returnBars;
bool   calculateValue;

//------------------------------------------------------------------
//                                                                  
//------------------------------------------------------------------
//
//
//
//
//

int init()
{
   IndicatorBuffers(4);
   SetIndexBuffer(0,macduw); SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexBuffer(1,macddw); SetIndexStyle(1,DRAW_HISTOGRAM);
   SetIndexBuffer(2,signal);
   SetIndexBuffer(3,trend);
   
      //
      //
      //
      //
      //
      //
   
      indicatorFileName = WindowExpertName();
      returnBars        = (TimeFrame == "returnBars");     if (returnBars)     return(0);
      calculateValue    = (TimeFrame == "calculateValue"); if (calculateValue) return(0);
      timeFrame         = stringToTimeFrame(TimeFrame);   

      //
      //
      //
      //
      //
   
  IndicatorShortName(timeFrameToString(timeFrame)+"  macd bars");
return(0);
}

//
//
//
//
//

int deinit(){ return(0); }

//------------------------------------------------------------------
//                                                                  
//------------------------------------------------------------------
//
//
//
//
//

int start()
{
   double alpha = 2.0/(1.0+SignalMa);
   int counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
         int limit = MathMin(Bars - counted_bars,Bars-1);
         if (returnBars) { macduw[0] = limit+1; return(0); }

   //
   //
   //
   //
   //
   
   if (calculateValue || timeFrame == Period())
   {

   for(int i = limit; i >= 0 ; i--)
   {
      double macd      = iMA(NULL,0,FastMa,0,mamode,Price,i) - iMA(NULL,0,SlowMa,0,mamode,Price,i);
             signal[i] = signal[i+1]+alpha*(macd-signal[i+1]);
             macduw[i] = EMPTY_VALUE;
             macddw[i] = EMPTY_VALUE;
             trend[i]  = trend[i+1];
             
               if (macd > signal[i]) trend[i] =  1;
               if (macd < signal[i]) trend[i] = -1;
      
               if (trend[i]== 1) { macduw[i] = High[i]; macddw[i] = Low[i]; }
               if (trend[i]==-1) { macddw[i] = High[i]; macduw[i] = Low[i]; }
               
   }
   manageAlerts();
   return(0);
   }
   
   //
      //
      //
      //
      //
      
      limit = MathMax(limit,MathMin(Bars-1,iCustom(NULL,timeFrame,indicatorFileName,"returnBars",0,0)*timeFrame/Period()));
         for(i=limit; i>=0; i--)
         {
            int y = iBarShift(NULL,timeFrame,Time[i]); 
               signal[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",FastMa,SlowMa,SignalMa,mamode,Price,2,y); 
               trend[i]  = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",FastMa,SlowMa,SignalMa,mamode,Price,3,y); 
               macduw[i] = EMPTY_VALUE;
               macddw[i] = EMPTY_VALUE;
    
         }
         
         for(i=limit; i>=0; i--)
         {
         
              if (trend[i]== 1) { macduw[i] = High[i]; macddw[i] = Low[i]; }
              if (trend[i]==-1) { macddw[i] = High[i]; macduw[i] = Low[i]; }
         }
   
   //
   //
   //
   //
   //
   
   manageAlerts();
   return(0);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = StringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}

//
//
//
//
//

string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

string StringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int char = StringGetChar(s, length);
         if((char > 96 && char < 123) || (char > 223 && char < 256))
                     s = StringSetChar(s, length, char - 32);
         else if(char > -33 && char < 0)
                     s = StringSetChar(s, length, char + 224);
   }
   return(s);
}

//
//
//
//
//

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

void manageAlerts()
{
   if (!calculateValue && alertsOn)
   {
      if (alertsOnCurrent)
           int whichBar = 0;
      else     whichBar = 1; whichBar = iBarShift(NULL,0,iTime(NULL,timeFrame,whichBar));
      if (trend[whichBar] != trend[whichBar+1])
      {
         if (trend[whichBar] == 1) doAlert(whichBar,"buy");
         if (trend[whichBar] ==-1) doAlert(whichBar,"sell");
      }         
   }
}   

//
//
//
//
//

void doAlert(int forBar, string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
   if (previousAlert != doWhat || previousTime != Time[forBar]) {
       previousAlert  = doWhat;
       previousTime   = Time[forBar];

       //
       //
       //
       //
       //

       message =  StringConcatenate(Symbol()," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," - ",timeFrameToString(timeFrame)+" macd bars ",doWhat);
          if (alertsMessage) Alert(message);
          if (alertsEmail)   SendMail(StringConcatenate(Symbol()," macd bars "),message);
          if (alertsSound)   PlaySound("alert2.wav");
   }
}

//
//
//
//
//



